<?php

  // Take a filename
  // Return true/false whether filename is a valid img file.
  function is_valid_img( $filename)
    {
      return( getimagesize($filename));
    };


  // Take a filename, a resolution, a md5, another filename.
  function create_image($orig_filename,$resolution,&$filename_md5,&$filename,&$url)
  {

    global $tagging, $convert_img_bin;
  
    // = creating the version to display if needed
    
    $size_array=getimagesize($orig_filename);
    $orig_res=$size_array[0] . "x" . $size_array[1];

    // = Tagging the proposed and usefull resolution
    
    $tagging=array();
    reset($resolution);
    while (list($key, $val) = each($resolution))
    {
      if (is_in_notstrict($orig_res, $val))
	$tagging[$key]="1"; // Tagging all res that contains $orig_res 
    };

    reset($resolution);
    while (list($key, $val) = each($resolution))
      {
	reset($tagging);
	while (list($key2, $val2) = each($tagging))
	  {
	    if (is_in($resolution[$key2], $val))
	      {
		$tagging[$key]="2"; // Tagging all res that contains strictly at least one tagged other res.
		break;
	      };
	  };
      };

    // = Using tagging information to simplify some resolution
    
    reset($tagging);
    while (list($key2, $val2) = each ($tagging))
      {
	if ($val2 >= "1")
	  {
	    $filename[$key2] = $filename["orig"];
	    $filename_md5[$key2] = $filename_md5["orig"];
	    $url[$key2] = $url["orig"];
	  };
      };

    $img_res=array();
    reset($resolution);
    while (list ($key, $val) = each ($resolution))
      {
	if (! array_key_exists($key,$tagging))
	  $img_res[$key]=reduce_to($orig_res, $val);
      };
    
    // = Find the greater included resolution

    // creating a table which associates to each resolution a number
    $tagging2=array();
    reset($img_res);
    while (list($key, $val) = each($img_res))
      {
	if (is_in($val, $orig_res))
	  $tagging2[$key]=1; // Associates "1" to resol that are contained in $orig_res
      };
    

    // tags "n" to files that are contained in res that are tagged "n-1"
    $nb=1;
    $new_loop = "yes";
    
    while ($new_loop == "yes")
      {
	$nb++;
	$new_loop="no";
	
	reset($img_res);
	while(list($key, $val) = each($img_res))
	  {
	    if($tagging2[$key] != $nb)
	      {
		reset($tagging2);
		while (list($key2, $val2) = each($tagging2))
		  {
		    if(($val2 == ($nb - 1)) && (is_in($val, $img_res[$key2])))
		      {
			$tagging2[$key]=$nb;
			$new_loop="yes";
			break;
		      };
		  };
	      };
	  };
      };
    
    // Sort by value (that is a number which represents the inclusions)
    asort($tagging2);

    if (!file_exists($filename_md5["orig"]))
      {
	system("cp \"". $orig_filename . "\" \"" . $filename_md5["orig"]  . "\"");
      };

    system("rm -f \"" . $filename["orig"] . "\"");
    system("cp -s \"" . $filename_md5["orig"] . "\" \"" . $filename["orig"] . "\"");
    
    $old_name=$filename_md5["orig"];
    
    // CONVERT with convert_img
        
    $command="$convert_img_bin \"$old_name\" ";
    
    reset($tagging2);
    while (list($key, $val) = each($tagging2))
      {
	if(!(file_exists($filename_md5[$key]) && is_valid_img($filename_md5[$key])))
	  {
	    //	    echo "$command<BR>";
	    $command .= $resolution[$key] . " \"" . $filename_md5[$key] . "\" ";
	  };
      };

    if ( $command != "$convert_img_bin \"$old_name\" ")
      {
	//echo("$command");
	system($command);
      };


    reset($tagging2);
    while (list($key, $val) = each($tagging2))
      {
	if (!file_exists($filename_md5[$key]))
	  {
	    display_error(<<<EOF
The Shadow-MD5 file '$filename_md5[$key]' does not exist.
It should have been created automagically precedently.
<B>You Must correct this error for phpview to display photo properly</B>
EOF
			  );
	    exit(1);
	  };

	    system("rm -f \"" . $filename[$key] . "\" ; cp -s \"" . $filename_md5[$key] . "\" \"" . $filename[$key] . "\"");
	
      };

  };


?>